local showSpells = true;
local showMaxLevelTraining = false;
local previousCount = 10;
local futureCount = 10;

local showFirstAid = true;

local showMining = true;

SLASH_KRYTEN1, SLASH_KRYTEN2 = "/kry", "/Kryten";
local function slashHandler(msg, editbox)
	local command, arg = msg:match("^(%S*)%s*(.-)$");
		-- Any leading non-whitespace is captured into command;
		-- the rest (minus leading whitespace) is captured into rest.
	if command == "previous" and arg ~= "" then
		previousCount = tonumber(arg);
		print("Kryten: Setting Previous levels shown to "..previousCount);
		-- Handle adding of the contents of rest... to something.
	elseif command == "future" and arg ~= "" then
		futureCount = tonumber(arg);
		print("Kryten: Setting Future levels shown to "..futureCount);
		-- Handle removing of the contents of rest... to something.   
	else
		-- If not handled above, display some sort of help message
		print("Syntax: /kry (previous|future) num");
	end
end
SlashCmdList["KRYTEN"] = slashHandler;

local UPDATEPERIOD, elapsed = 0.5, 0
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:NewDataObject("Kryten", {
	type = "data source",
	icon = "Interface\\Icons\\INV_Misc_Statue_08",
	text = "Kryten",
})
local f = CreateFrame("frame")

local rfStatus = "Unknown!";
local kryLevel = "Unknown!";
local kryJP = "Unknown!";
local kryVP = "Unknown!";

f:SetScript("OnUpdate", function(self, elap)
	elapsed = elapsed + elap;
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0;

	if UnitLevel("player") == 85 then
		kryLevel = "iLvl: |cff00ff00"..floor(GetAverageItemLevel()).."|r";
	else
		kryLevel = "Lvl: |cff00ff00"..UnitLevel("player").."|r";
	end

	local id2,name2,typeId2,subType2,minLvl2,maxLvl2,recLvl2,minRecLvl2,maxRecLvl2,expid2,groupId2,tex2,diff2,maxPl2,desc2,isHol2 = GetRFDungeonInfo(2);
	local numEncounters2, numCompleted2 = GetLFGDungeonNumEncounters(id2);
	local lastBoss2 = false;
	
	if select(3,GetLFGDungeonEncounterInfo(id2, 4)) then
		lastBoss2 = true;
	end

	local id1,name1,typeId1,subType1,minLvl1,maxLvl1,recLvl1,minRecLvl1,maxRecLvl1,expid1,groupId1,tex1,diff1,maxPl1,desc1,isHol1 = GetRFDungeonInfo(1);
	local numEncounters1, numCompleted1 = GetLFGDungeonNumEncounters(id1);
	local lastBoss1, lastBoss2 = (select(3,GetLFGDungeonEncounterInfo(id1, 8))), (select(3,GetLFGDungeonEncounterInfo(id2, 4)));
	
	if numCompleted1 == 4 and numCompleted2 == 4 then
		rfStatus = "|cff00FF002|r/|cff00FF002|r";
	elseif lastBoss1 and lastBoss2 then
		rfStatus = "|cffFFFF002|r/|cffFFFF002|r";
	elseif lastBoss1 or lastBoss2 and (numCompleted1 == 4 or numCompleted2 == 4) then
		rfStatus = "|cffFFFF001|r/|cffFFFF002|r";
	elseif numCompleted1 == 4 or numCompleted2 == 4 then
		rfStatus = "|cff00FF001|r/|cff00FF002|r";
	elseif lastBoss1 or lastBoss2 then
		rfStatus = "|cffFFFF001|r/|cffFFFF002|r";
	elseif UnitLevel("player") == 85 and floor(GetAverageItemLevel()) >= 372 then
		rfStatus = "|cffff44440|r/|cffff44442|r";
	else
		rfStatus = "|cffff4444N/A|r";
	end

	local justiceName,justiceAmount,justiceTexture,justiceEarnedThisWeek,justiceWeeklyMax,justiceTotalMax,justiceIsDiscovered = GetCurrencyInfo(395);

	if justiceIsDiscovered then
		kryJP = "  |TInterface\\ICONS\\"..justiceTexture..":0|t |cff00ff00" .. justiceAmount .. "|r";
	else
		kryJP = "";
	end

	local valorName,valorAmount,valorTexture,valorEarnedThisWeek,valorWeeklyMax,valorTotalMax,valorIsDiscovered = GetCurrencyInfo(396);

	if valorIsDiscovered then
		kryVP = "  |TInterface\\ICONS\\"..valorTexture..":0|t |cff00ff00" .. valorAmount .. "|r (|cff00ff00"..valorEarnedThisWeek.."|r)";
	else
		kryVP = "";
	end

	if UnitLevel("player") == 85 and floor(GetAverageItemLevel()) >= 372 then
		dataobj.text = " "..kryLevel.."  RF: "..rfStatus..kryJP..kryVP;
	else
		dataobj.text = " "..kryLevel..kryJP..kryVP;
	end
end)

local ICON_GOLD = "\124TInterface\\MoneyFrame\\UI-GoldIcon:12:12\124t"
local ICON_SILVER = "\124TInterface\\MoneyFrame\\UI-SilverIcon:12:12\124t"
local ICON_COPPER = "\124TInterface\\MoneyFrame\\UI-CopperIcon:12:12\124t"

local spellsAreLearned = false;

function TrainedSpellsByLevel(classTable, level, showCost)
	if classTable[level] and #classTable[level] > 0 then
		for i=1, #classTable[level] do

			local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(classTable[level][i].ID)
			local Tree = "";
			
			if IsSpellKnown(classTable[level][i].ID) then
				if classTable[level][i].Tree ~= "" then
					Tree = " (|cff00ff00"..classTable[level][i].Tree.."|r)";
				end
				if not spellsAreLearned then
					GameTooltip:AddLine(" ");
					GameTooltip:AddLine("Trained (Last "..previousCount.." levels):");
					spellsAreLearned = true;
				end
				if classTable[level][i].Alliance and UnitFactionGroup("player") == "Horde" then
				elseif classTable[level][i].Horde and UnitFactionGroup("player") == "Alliance" then
				else
					if not name then
						print("Kryten: Could not find the Spell Info for ID: "..classTable[level][i].ID);
					else
						GameTooltip:AddDoubleLine("|T"..icon..":0|t |cff00FF00|Hspell:".. classTable[level][i].ID .."|h[".. name .."]|h|r", classTable[level][i].Type .. Tree);
					end
				end
			elseif classTable[level][i].Type == "Tracking" then
				local count = GetNumTrackingTypes();
				for x=1,count do 
					local trackName, texture, active, category = GetTrackingInfo(x);
					if classTable[level][i].Name == trackName then
						if not spellsAreLearned then
							GameTooltip:AddLine("Trained (Last "..previousCount.." levels):");
							spellsAreLearned = true;
						end
						if classTable[level][i].Alliance and UnitFactionGroup("player") == "Horde" then
						elseif classTable[level][i].Horde and UnitFactionGroup("player") == "Alliance" then
						else
							if not name then
								print("Kryten: Could not find the Spell Info for ID: "..classTable[level][i].ID);
							else
								GameTooltip:AddDoubleLine("|T"..icon..":0|t |cff00FF00|Hspell:".. classTable[level][i].ID .."|h[".. name .."]|h|r", classTable[level][i].Type .. Tree);
							end
						end
					end
				end
			end
		end
	end
end

function moneyFormatter(rawCopper)
	local copper = rawCopper % 100;
	local money = (rawCopper - copper) / 100;
	local silver = money % 100
	local gold = math.floor(money / 100)
	money = "";
	if gold > 0 then money = gold..ICON_GOLD; end
	if gold > 0 and (silver > 0 or copper > 0) then money = money .. " "; end
	if silver > 0 then money = money..silver..ICON_SILVER; end
	if (gold > 0 or silver > 0) and copper > 0 then money = money .. " "; end
	if copper > 0 then money = money..copper..ICON_COPPER; end
	return money;
end

local spellsAreAvailable = false;
local spellsAreAvailableSoon = false;
local trackingFound = false;

function AvailableSpellsByLevel(classTable, level, showCost)
	if classTable[level] and #classTable[level] > 0 then
		for i=1, #classTable[level] do

			local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(classTable[level][i].ID)

			if IsSpellKnown(classTable[level][i].ID) then
				-- Known!
			elseif level <= UnitLevel("player") and classTable[level][i].Type == "Tracking" then
				-- Check for known Tracking abilities
				local count = GetNumTrackingTypes();
				for x=1,count do
					local trackName, texture, active, category = GetTrackingInfo(x);
					if classTable[level][i].Name == trackName then
						trackingFound = true;
					end
					if not trackingFound then
						if classTable[level][i].Alliance and UnitFactionGroup("player") == "Horde" then
						elseif classTable[level][i].Horde and UnitFactionGroup("player") == "Alliance" then
						else
							if not name then
								print("Kryten: Could not find the Spell Info for ID: "..classTable[level][i].ID);
							else
								if not spellsAreAvailable then
									GameTooltip:AddLine(" ");
									GameTooltip:AddLine("Trainable:");
									spellsAreAvailable = true;
								end
								GameTooltip:AddDoubleLine("|T"..icon..":0|t |cffFFFF00|Hspell:".. classTable[level][i].ID .."|h[".. name .."]|h|r", classTable[level][i].Type .. " (|cff00ff00Level " .. level .. "|r)   " .. moneyFormatter(classTable[level][i].Cost));
							end
						end
					end
				end
			elseif level <= UnitLevel("player") then
				if classTable[level][i].Alliance and UnitFactionGroup("player") == "Horde" then
				elseif classTable[level][i].Horde and UnitFactionGroup("player") == "Alliance" then
				else
					if not name then
						print("Kryten: Could not find the Spell Info for ID: "..classTable[level][i].ID);
					else
						if not spellsAreAvailable then
							GameTooltip:AddLine(" ");
							GameTooltip:AddLine("Trainable:");
							spellsAreAvailable = true;
						end
						GameTooltip:AddDoubleLine("|T"..icon..":0|t |cffFFFF00|Hspell:".. classTable[level][i].ID .."|h[".. name .."]|h|r", classTable[level][i].Type .. " (|cff00ff00Level " .. level .. "|r)   " .. moneyFormatter(classTable[level][i].Cost));
					end
				end
			elseif level > UnitLevel("player") then
				if classTable[level][i].Alliance and UnitFactionGroup("player") == "Horde" then
				elseif classTable[level][i].Horde and UnitFactionGroup("player") == "Alliance" then
				else
					if not name then
						print("Kryten: Could not find the Spell Info for ID: "..classTable[level][i].ID);
					else
						if not spellsAreAvailableSoon then
							GameTooltip:AddLine(" ");
							GameTooltip:AddLine("Upcoming (Next "..futureCount.." levels):");
							spellsAreAvailableSoon = true;
						end
						GameTooltip:AddDoubleLine("|T"..icon..":0|t |cffFF4444|Hspell:".. classTable[level][i].ID .."|h[".. name .."]|h|r", classTable[level][i].Type .. " (|cff00ff00Level " .. level .. "|r)   " .. moneyFormatter(classTable[level][i].Cost));
					end
				-- GameTooltip:AddLine(GetSpellDescription(classTable[level][i].id),1 ,1 ,1 ,1);
				end
			end
		end
	end
end

function dataobj:OnTooltipShow()
	if UnitLevel("player") == 85 and floor(GetAverageItemLevel()) >= 372 then
		self:AddDoubleLine("|cffffff00RaidFinder:|r",rfStatus);

		local id2,name2,typeId2,subType2,minLvl2,maxLvl2,recLvl2,minRecLvl2,maxRecLvl2,expid2,groupId2,tex2,diff2,maxPl2,desc2,isHol2 = GetRFDungeonInfo(2);
		local numEncounters2, numCompleted2 = GetLFGDungeonNumEncounters(id2);
		local bosses2 = {};
		bosses2.order = {};

		for i = 1, 4 do
			local bossName2, _2, isKilled2 = GetLFGDungeonEncounterInfo(id2, i);
			if isKilled2 then
				table.insert(bosses2.order, bossName2);
				bosses2[bossName2] = true;
			else
				table.insert(bosses2.order, bossName2);
				bosses2[bossName2] = false;
			end
		end

		self:AddLine(name2);
		self:AddTexture("Interface\\LFGFRAME\\LFGIcon-SiegeofWyrmrestTemple");
		for i = 1, 4 do
			if bosses2.order[i] then
				if bosses2[bosses2.order[i]] then
					self:AddDoubleLine("|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:0|t |cffff4444"..bosses2.order[i].."|r", "|cffff4444DEAD|r");
				else
					self:AddDoubleLine("|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:0|t |cff00ff00"..bosses2.order[i].."|r", "|cff00ff00ALIVE|r");
				end
			end
		end
		self:AddLine(" ");

		local id1,name1,typeId1,subType1,minLvl1,maxLvl1,recLvl1,minRecLvl1,maxRecLvl1,expid1,groupId1,tex1,diff1,maxPl1,desc1,isHol1 = GetRFDungeonInfo(1);
		local numEncounters1, numCompleted1 = GetLFGDungeonNumEncounters(id1);
		local bosses1 = {};
		bosses1.order = {};

		for i = 5, 8 do
			local bossName1, _1, isKilled1 = GetLFGDungeonEncounterInfo(id1, i);
			if isKilled1 then
				table.insert(bosses1.order, bossName1);
				bosses1[bossName1] = true;
			else
				table.insert(bosses1.order, bossName1);
				bosses1[bossName1] = false;
			end
		end

		self:AddLine(name1);
		self:AddTexture("Interface\\LFGFRAME\\LFGIcon-FallofDeathwing");
		for i = 1, 4 do
			if bosses1.order[i] then
				if bosses1[bosses1.order[i]] then
					self:AddDoubleLine("|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:0|t |cffff4444"..bosses1.order[i].."|r", "|cffff4444DEAD|r");
				else
					self:AddDoubleLine("|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_8:0|t |cff00ff00"..bosses1.order[i].."|r", "|cff00ff00ALIVE|r");
				end
			end
		end
		self:AddLine(" ");
	end

	if UnitLevel("player") == 85 then
		self:AddDoubleLine("Average Item Level:", "|cff00ff00"..floor(GetAverageItemLevel()).."|r");
	else
		local levelsToGo = 85 - UnitLevel("player");
		self:AddDoubleLine("Level: |cff00ff00"..UnitLevel("player").."|r", "(|cff00ff00"..levelsToGo.."|r to go!)");
	end

	local justiceName,justiceAmount,justiceTexture,justiceEarnedThisWeek,justiceWeeklyMax,justiceTotalMax,justiceIsDiscovered = GetCurrencyInfo(395);

	if justiceIsDiscovered then
		self:AddDoubleLine("|TInterface\\ICONS\\"..justiceTexture..":0|t "..justiceName..":", "|cff00ff00" .. justiceAmount .. "|r/|cff00ff00" .. (justiceTotalMax/100) .. "|r");
	end

	local valorName,valorAmount,valorTexture,valorEarnedThisWeek,valorWeeklyMax,valorTotalMax,valorIsDiscovered = GetCurrencyInfo(396);

	if valorIsDiscovered then
		self:AddDoubleLine("|TInterface\\ICONS\\"..valorTexture..":0|t "..valorName.." this week:", "|cff00ff00" .. valorEarnedThisWeek .. "|r/|cff00ff001000|r");
	end

	local level = UnitLevel("player");
	local classTable = {};

	if Kryten_classData[UnitClass("player")] and showSpells and (UnitLevel("player") ~= 85 or showMaxLevelTraining) then
		classTable = Kryten_classData[UnitClass("player")];
	elseif showSpells and (UnitLevel("player") ~= 85 or showMaxLevelTraining) then
		self:AddLine(" ");
		self:AddLine("|cffff4444No data for "..UnitClass("player").." class. :(|r");
	end

	if classTable and showSpells and (UnitLevel("player") ~= 85 or showMaxLevelTraining) then
		-- Learned
		if previousCount > 0 then
			for i = previousCount, 1, -1 do
				TrainedSpellsByLevel(classTable, level-i, false);
			end
			TrainedSpellsByLevel(classTable, level, false);
		end
		-- Available & Future
		for i=1, level+futureCount do
			AvailableSpellsByLevel(classTable, i, true);
		end
	end

	if showFirstAid then KrytenFirstAidModule(); end
	if showMining then KrytenMiningModule(); end
end

function dataobj:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT")
	GameTooltip:ClearLines()
	dataobj.OnTooltipShow(GameTooltip)
	GameTooltip:Show()
end

function dataobj:OnLeave()
	GameTooltip:Hide()
	spellsAreAvailable = false;
	spellsAreAvailableSoon = false;
	spellsAreLearned = false;
end
